import ts from "typescript";
import { arch } from "@plutolang/base";
import { ImportElement } from "./imports";
export interface ResourceVariableInfo {
    varName: string;
    resourceConstructInfo: ResourceConstructInfo;
}
export interface ResourceRelationshipInfo {
    fromVarName: string;
    toVarNames: string[];
    type: arch.RelatType;
    operation: string;
    parameters: ParameterInfo[];
}
export interface ResourceRelatVarUnion {
    resourceRelatInfos: ResourceRelationshipInfo[];
    resourceVarInfos: ResourceVariableInfo[];
}
export interface ResourceConstructInfo {
    constructExpression: string;
    importElements: ImportElement[];
    parameters?: ts.Expression[];
    locations: Location[];
}
export interface ParameterInfo {
    name: string;
    resourceName?: string;
    expression: ts.Expression;
    order: number;
}
export interface Location {
    file: string;
    depth: number;
    start: string;
    end: string;
}
