import ts from "typescript";
import { Location } from "./types";
export declare function isPrimitive(val: string): boolean;
export declare function getLocationOfNode(node: ts.Node, depth?: number): Location;
/**
 * Check if a variable is a resource.
 */
export declare function isResourceVar(node: ts.Node, checker: ts.TypeChecker): boolean;
/**
 * Check if a type is function.
 */
export declare function isFunctionType(type: ts.Type): boolean;
/**
 * Check if the declaration implements or extends the Resource interaface.
 * First, analyze the import dependencies of the source file for the current type node.
 * Then, check if the base types of this declaration are from the Resource interface in the plutolang base package.
 * If not, recursively check each base type.
 */
export declare function isResourceType(declNode: ts.ClassDeclaration | ts.InterfaceDeclaration, checker: ts.TypeChecker, fnResource?: boolean): boolean;
/**
 * Check if a symbol is a constant variable.
 */
export declare function isConstVar(symbol: ts.Symbol): boolean;
